import { Bot } from "grammy";
import { BotContext } from "../mod.ts";
import { IButtonCallbackData } from "../keyboards/mod.ts";
import { CallbackQueryEnum, voteCallback } from "./mod.ts";

export const setupCallbackQueries = (bot: Bot<BotContext>) => {
  bot.on("callback_query:data", (ctx) => {
    const callbackQueryData = JSON.parse(
      ctx.callbackQuery.data,
    ) as IButtonCallbackData;

    switch (callbackQueryData.cq) {
      case CallbackQueryEnum.APPROVE:
      case CallbackQueryEnum.REJECT:
        voteCallback(ctx, bot, callbackQueryData);
        break;
      default:
        throw new Error("Invalid callback query data");
    }
  });

  console.log("Callback Queries setup complete");
};
