import { InlineKeyboardButton } from "https://deno.land/x/grammy_types@v3.4.6/mod.ts";
import { CallbackQueryEnum } from "../callbackQueries/mod.ts";
import { IButtonCallbackData } from "./mod.ts";

const getVoteButtonCallbackData = (sid: number, isApprove: boolean) =>
  JSON.stringify({
    cq: isApprove ? CallbackQueryEnum.APPROVE : CallbackQueryEnum.REJECT,
    sid,
  } as IButtonCallbackData);

export const getPostApprovalKeyboard = (
  sid: number,
): InlineKeyboardButton[][] => [
  [
    {
      text: "🟢",
      callback_data: getVoteButtonCallbackData(sid, true),
    },
    {
      text: "🔴",
      callback_data: getVoteButtonCallbackData(sid, false),
    },
  ],
];

export const getPostOutcomeKeyboard = (
  isApproved: boolean,
): InlineKeyboardButton[][] => [
  [
    {
      text: isApproved ? "✅ Approved" : "❌ Rejected",
      callback_data: "noop",
    },
  ],
];
